// Reading in concatenated sample data

(
var x;
~sampseq = [];
x = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/sampseq/tellersylls.csv");
x.do { |item, i|
	if (item.size != 1) {~sampseq = ~sampseq.add(item)}
};
)

(
d = Dictionary.new;
~sampseq.do { |item, i| d.add(item[1].asSymbol -> []); };
d.postln;
d.removeAt(\midinote); // remove the cv header row
~sampseq.do { |item, i| d[item[1].asSymbol] = d[item[1].asSymbol].add(item); }
)

(
var subdict;
subdict = Dictionary.new;
d.keysDo { |key| subdict.add(key -> d[key].size); };
subdict.keysValuesDo { |key, value| postln("the key: " ++ key ++ " the value: " ++ value) };
)

s.boot;
b = Buffer.read(s, "/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/sampseq/tellersylls.wav", action: { arg buffer; buffer.updateInfo;};	);
b.play;
b.postln;


//Testing playback of random syllables from concatenated sample file
(
var sel_array, startpos, startframe, endpos;
sel_array = d.choose.choose;
startpos = sel_array[4].asInteger;
sel_array[1].postln;
startframe.postln;
{PlayBuf.ar(1, 0, startPos: startpos, doneAction:2)}.play;
)
d[\sp][0][4].postln;
d[\sp][0].postln;


//Reading in sequence information from original speech samples
(
// y for sYllable sequence
y = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/syll.csv");
y = y[0];
y = y.collect { |item, i| item.asSymbol };
y = y.drop(1);
y.size.postln;
// n for Note sequence
n = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/note.csv");
n = n[0];
n = n.collect { |item, i| item.asInteger };
n.size.postln;
// u for dUration sequence
u = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/dur.csv");
u = u[0];
u = u.collect { |item, i| item.asFloat };
u.size.postln;
)
y.size.postln;

(
~selectlongestsyll = {
	//Takes array of syllables from value of d, returns index representing longest syllable snippet
	arg syllarray;
	var durs, max, maxindex;
	max = 0.0;
	maxindex = 0;
	durs = Array.new(syllarray.size);
	syllarray.do({ |item, i| if(item[6].asFloat > max) {max = item[6].asFloat; maxindex = i} });
	syllarray[maxindex]
};
)
d[\AE1ND].postln;
~selectlongestsyll.value(d[\AE1ND]).postln;

// This works!!!
(
var syllstream, notestream, durstream,
syllmarkov, notemarkov, durmarkov;
syllstream = Pseq(y, 1).asStream;
notestream = Pseq(n, 1).asStream;
durstream = Pseq(u, 1).asStream;
syllmarkov = MarkovSetN.fill(2490, syllstream, 1);
syllmarkov.makeSeeds;
notemarkov = MarkovSet.fill(1792, notestream);
notemarkov.makeSeeds;
durmarkov = MarkovSet.fill(2491, durstream);
durmarkov.makeSeeds;

//z comes after y (for syllable markov stream)
z = syllmarkov.asStream;
//32.do {z.next.postln;};

//o comes after n (for note markov stream)
o = notemarkov.asStream;
//32.do {o.next.postln;};

//v comes after u (for duration markov stream)
v = durmarkov.asStream;
//32.do { v.next.postln;};
)


//Holy hell this works!
(
SynthDef.new(\bufplay, {
	arg buf=0, amp=1, rate=1, snippet=d[\sp][0], startpos=d[\sp][0][4].asInteger-4800, dur=(snippet[6].asFloat/48000.0+0.1), note=40;
	var sig, env;
	//env = EnvGen.ar(Env.triangle(dur, amp), doneAction:2);
	//env = EnvGen.ar(Env.asr(dur*0.01, amp, dur*0.01), doneAction:2); //doesn't work!
	//env = EnvGen.ar(Env.sine(dur, amp), doneAction: 2);
	env = EnvGen.ar(Env.xyc([[0,0,\sin],[0.03*dur,amp,\sin],[0.94*dur,amp,\sin],[dur,0,\sin]]), doneAction: 2);
	sig = PlayBuf.ar(1, buf, BufRateScale.ir(buf) * rate, startPos: startpos, doneAction: 2) * env;

	sig = sig * amp;
	Out.ar(0, sig);
}).add;
)

d.postln;

//s.prepareForRecord;

(
Pdef(
	\speak,
	Pbind(
		\instrument, \bufplay,
		\buf, 0,
		\syll, Pfunc{z.next}.trace,
		\snippet, Pfunc{|ev| ~selectlongestsyll.value(d[ev.syll.asSymbol])}.trace,
		\startpos, Pfunc{|ev| ev.snippet[4].asInteger-4800}, //.trace, //Pkey(\snippet)[4].asInteger,
		\dur, Pfunc{|ev| ev.snippet[6].asFloat/48000.0-(0.1* (ev.snippet[6].asFloat/48000.0))}.trace, //Pkey(\snippet)[6].asInteger,
		\legato, Pfunc{|ev| ((ev.snippet[6].asFloat/48000) + ((ev.snippet[6].asFloat/48000) * 0.2))/(ev.snippet[6].asFloat/48000) }.trace,
		\rate, 1,
		\amp, 0.8,
	);
).play;
//s.record;
)

//s.stopRecording;

// Warp1 synth under construction!!!

(
SynthDef.new(\warpbufplay, {
	arg buf=0, amp=1, rate=1, snippet=d[\sp][0], startpos=d[\sp][0][4].asInteger-4800, dur=(snippet[6].asFloat/48000.0+0.1), note=40;
	var sig, env,
	// declare vars for warp1
	sig2, snipstart, snipstop, pointer, totallen, pitchwarp, durwarp;
	env = EnvGen.ar(Env.triangle(dur, amp), doneAction:2);
	//sig = PlayBuf.ar(1, buf, BufRateScale.ir(buf) * rate, startPos: startpos) * env;

	totallen = buf.numFrames;
	pointer = Line.ar(
		snippet[4].asFloat/totallen.asFloat,
		snippet[5].asFloat/totallen.asFloat,
		snippet[6].asFloat/totallen.asFloat
	);
	pitchwarp = note.midicps/snippet[2].asInt.midicps;
	sig2 = Warp1.ar(1, buf, pointer, pitchwarp, windowSize: 0.2, envbufnum: -1, overlaps: 8, windowRandRatio: 0, interp: 1, mul: 1, add: 0) * env;
	//sig = sig * amp;
	sig2 = sig2 * amp;
	//Out.ar(0, sig);
	Out.ar(0, sig2);
}).add;
)





(
// y for sYllable sequence
y = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/syll.csv");
y = y[0];
y = y.collect { |item, i| item.asSymbol };
y = y.drop(1);
y.size.postln;
// n for Note sequence
n = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/note.csv");
n = n[0];
n = n.collect { |item, i| item.asInteger };
n.size.postln;
// u for dUration sequence
u = CSVFileReader.read("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/dur.csv");
u = u[0];
u = u.collect { |item, i| item.asFloat };
u.size.postln;
)
y.size.postln;


// This works!!!
(
var syllstream, notestream, durstream,
syllmarkov, notemarkov, durmarkov;
syllstream = Pseq(y, 1).asStream;
notestream = Pseq(n, 1).asStream;
durstream = Pseq(u, 1).asStream;
syllmarkov = MarkovSet.fill(2490, syllstream);
syllmarkov.makeSeeds;
notemarkov = MarkovSet.fill(1792, notestream);
notemarkov.makeSeeds;
durmarkov = MarkovSet.fill(2491, durstream);
durmarkov.makeSeeds;

//z comes after y (for syllable markov stream)
z = syllmarkov.asStream;
//32.do {z.next.postln;};

//o comes after n (for note markov stream)
o = notemarkov.asStream;
//32.do {o.next.postln;};

//v comes after u (for duration markov stream)
v = durmarkov.asStream;
//32.do { v.next.postln;};
)


m.next;
8.do {m.next([\sp]).postln; };


~pathlst = PathName("/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/sox_syll/out").files;
~filelst = ~pathlst.collect { |item, i| item.fileName; };
~sylllst = ~filelst.collect { |item, i| item.split($.)[0].asSymbol; };
~notelst = ~filelst.collect { |item, i| item.split($.)[1].asInteger; };
~sylllst.size.postln;
~syllst.postln;
m = ShannonMarkovSet.new(2242);
m.data = y;
y = m.asStream(2242);
10.do({ y.next.postln });
m.data;
(
60.do({ arg i;
	m.put(i,y.next).postln;
});
)

y.next.post; Char.tab.post };

a = ShannonMarkovSet.new(800);
q = Pseq([0,1,2,3]+10,inf).asStream;
(
120.do({ arg i;
	a.put(i,q.next)
})
);


v = a.asStream(3);
10.do({ v.next.postln });

a.next(11).postln;

a.data;

z = 5;
a.nextIndex(z).postln;

// empty set test.

a = ShannonMarkovSet(256);
a.chooseIndex.postln;
a.nextIndex(0).postln;
v = a.asStream(8,1);
v.next.postln;
