#!/usr/bin/env python 2.7

import os
import pdb

class sample_file:
    def __init__(self, fname):
        self.fname = fname
        self.fields = [x for x in self.fname.split('.')]
        self.syllable = self.fields[0]
        try:
            self.midi_note = int(self.fields[1])
        except:
            self.midi_note = None
        try:
            self.duration = float(self.fields[2] + '.' + self.fields[3])
        except:
            self.duration = None
        try:
            self.intensity = int(self.fields[4])
        except:
            self.intensity = None
        self.format = self.fields[5]

class dict_entry:
    def __init__(self, samp_lst, classifier):
        if self.classifier == 'syllable':
            self.symbol = samp_lst[0].syllable
        elif self.classifier == 'midi_note':
            self.symbol = samp_lst[0].midi_note
        elif self.classifier == 'duration':
            self.symbol = samp_lst[0].duration
        else:
            print 'For %r, %s an unknown classifier. Use syllable, midi_note, or duration.' % (self, self.classifier)
    
    def write_str(self):
        '''I'm lost'''

def r_walk_dir(d):
    '''recursively walks directory given as d, returns list of sample files in directory'''
    os.chdir(d)
    file_lst = []
    for root, dirs, files in os.walk(d):
        print files
        if len(files) != 0:
            for f in files:
                if len(f.split('.')) == 6 and f.split('.')[5] == 'wav':
                    file_lst.append(f)
        if len(dirs) != 0:
            sub_file_lst = [r_walk_dir(d+direc) for direc in dirs]
            for f in sub_file_lst:
                try:
                    if len(f.split('.')) == 6 and f.split('.')[5] == 'wav':
                        file_lst.append(f)
                except:
                    print 'oops'
                    
    return file_lst

def main():
    in_dir = '/Users/jamesanderson-furgeson/tellerstar/supercollider_files/teller_samps/test/'
    file_lst = r_walk_dir(in_dir)
    samps = [sample_file(f) for f in file_lst]
    
        
if __name__ == '__main__':
    main()